#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <string>

using std::string;

/* Global options. */

extern const char* SerialPort;
extern bool Verbose;

/* Utilities. */

extern "C" const uint32_t crctable[];

extern void error(const char* message, ...);
extern void verbose(const char* message, ...);
extern void warning(const char* message, ...);
extern void resettimer();
extern uint32_t gettime();

extern bool BeginsWith(const string& haystack, const string& needle);
extern uint16_t CRC16(const uint8_t* data, int size);
extern uint32_t CRC32(const uint8_t* data, int size);

/* Serial port management. */

extern void serial_connect();
extern void sendbyte(uint8_t c);
extern uint8_t recvbyte();
extern void sendquad(uint32_t q);
extern uint32_t recvquad();

extern void dodgyterm();

/* Remote terminal. */

extern void remote_connect();

/* Commands. */

extern void cmd_readnand(char* const* argv);
extern void cmd_writenand(char* const* argv);

#endif

