local io_open = io.open
local string_len = string.len
local string_byte = string.byte

bintoc = simple {
	class = "bintoc",
	ensure_n_children = 1,
	outputs = {"%U%/%I%.c"},
	command = "",
	
   __init = function(self, p)
		simple.__init(self, p)
                
		-- If we're a class, don't verify.
                
        if ((type(p) == "table") and p.class) then
            return
        end

	    -- outputs must exist, and must be a table.
	    
	    if not self.outputs then
            self:__error("must have an outputs template set")
	    end
                
        if (type(self.outputs) ~= "table") then
            self:__error("doesn't know what to do with its outputs, which is a ",
				type(self.outputs), " but should be a table")
        end

		-- There must be a 'symbol' property.
		
		if not self.symbol then
			self:__error("must have a symbol name specified")
		end
	end,                                    
	
    __dobuild = function(self, inputs, outputs)
    	print("bintoc "..inputs[1].." -> "..outputs[1])
    	
    	local inputfp = io_open(inputs[1], "rb")
    	local outputfp = io_open(outputs[1], "w")
    	
    	outputfp:write("const unsigned char "..self.symbol.."_data[] = {\n")
    	
    	local inputdata = inputfp:read("*a")
    	local size = string_len(inputdata)
    	
    	for i = 1, size do
    		local b = string_byte(inputdata, i)
    		outputfp:write("\t"..b..",\n")
    	end    		
    	
    	outputfp:write("};\n")
    	outputfp:write("const unsigned int "..self.symbol.."_size = "..
    		size..";\n")
    	
    	inputfp:close()
    	outputfp:close()
    end
}	